//---------------------------------------------------------------------------
#include <vcl.h>
#include <vfw.h>
#include <stdio.h>

#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

typedef   struct   _VIDEO_DATA
{
        BOOL   bKeyFrame;
        DWORD   nSampleNum;
        DWORD   nUsedSize;
        BYTE   Buf[8180];
}VIDEO_DATA;

BITMAPINFOHEADER BitmapInfoHead;
BITMAPINFO BmpInInfo;
BITMAPINFO *BmpOutInfo;
COMPVARS CapVar;
VIDEO_DATA VideoData;
BOOL bKeyFrame;
LPVOID Buf;

LRESULT CALLBACK FrameCallBack(HWND hWnd, LPVIDEOHDR lpVHdr )
{

        DWORD OutActSize;

        long OutActSize2;
        OutActSize = BmpInInfo.bmiHeader.biSizeImage;
        OutActSize2 = OutActSize;

        Buf = ICSeqCompressFrame(&CapVar,0,lpVHdr->lpData,&bKeyFrame,&OutActSize2) ;


        if (OutActSize2 <= 8180 )
        {
                ZeroMemory(&VideoData ,sizeof(VIDEO_DATA));
                VideoData.bKeyFrame = bKeyFrame;  //OO_Frame

                CopyMemory(&VideoData.Buf, Buf, OutActSize2);
                VideoData.nUsedSize = OutActSize2; //OƤjp, ǿɥ

                if(bKeyFrame)
                        Form1->Button4->Click();   
        }


        return 0;
}


bool InitCaptureParams()
{
        bool result = false;
        DWORD OutFormatSize,OutBufferSize;


        ZeroMemory(&CapVar,sizeof(COMPVARS));
        CapVar.cbSize     = sizeof(CapVar);
        CapVar.dwFlags    = ICMF_COMPVARS_VALID;
        CapVar.cbState    = 0;

        CapVar.fccHandler = mmioFOURCC('d','i','v','x');
        CapVar.fccType    = ICTYPE_VIDEO;

        CapVar.hic = ICOpen(ICTYPE_VIDEO,CapVar.fccHandler,ICMODE_COMPRESS);

        if(CapVar.hic > 0)
        {
                OutFormatSize = ICCompressGetFormatSize(CapVar.hic,&BmpInInfo.bmiHeader);

                BmpOutInfo = new BITMAPINFO[sizeof(OutFormatSize)];
                ICCompressGetFormat(CapVar.hic,&BmpInInfo.bmiHeader,&BmpOutInfo->bmiHeader);
                OutBufferSize = ICCompressGetSize(CapVar.hic,&BmpInInfo.bmiHeader,&BmpOutInfo->bmiHeader);
                ICSeqCompressFrameStart(&CapVar,&BmpInInfo);

                result = true;
        }
        else
        {
                ShowMessage("Хw˵TYsX");
                return result;
        }
        return result;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
        char i,count = 0;
        char Driver_name[80];
        char Driver_version[80];
        for(i = 0 ; i < 10 ; i++)
                if(capGetDriverDescription(i,Driver_name,80,Driver_version,80))
                {
                        count++;
                        break;
                }
        if(count == 0)
        {
                ShowMessage("<䤣T˸mXʵ{...>");
                return;
        }

        HCamWin = capCreateCaptureWindow("TEXT",WS_CHILD|WS_VISIBLE,
                        0,0,Panel1->Width,Panel1->Height,Panel1->Handle,0);


        if (HCamWin == 0)
        {
                ShowMessage("Lkl...");
                return;
        }

        if (capDriverConnect(HCamWin,0))
        {
                capPreviewScale(HCamWin,false);
                capPreviewRate(HCamWin,1000/rate);
                capPreviewScale(HCamWin,1);
                MoveWindow(HCamWin,0,0,Panel1->Width,Panel1->Height,1);
                capPreview(HCamWin,true);
                capGetVideoFormat(HCamWin,&BitmapInfoHead,capGetVideoFormatSize(HCamWin));
                Image1->Picture->Bitmap->PixelFormat=pf24bit;
        }

        else
        {
                ShowMessage("Lkv^,нTwT˸mTsAդ@");
                return;
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Source1Click(TObject *Sender)
{
        capDlgVideoSource(HCamWin); //video source
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Format1Click(TObject *Sender)
{
        capDlgVideoFormat(HCamWin); //video format
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
        capGetVideoFormat(HCamWin,&BmpInInfo,sizeof(BITMAPINFO));
        capSetCallbackOnFrame(HCamWin,&FrameCallBack);
        InitCaptureParams();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{

        if(CapVar.hic > 0)
        {
                ICSeqCompressFrameEnd(&CapVar);
                ICCompressorFree(&CapVar);
                ICClose(CapVar.hic);
        }
        delete(BmpOutInfo);

        if (HCamWin != 0)
        {
                capDriverDisconnect(HCamWin);
                DestroyWindow(HCamWin);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
        COMPVARS CapVar1= CapVar ;
        BITMAPINFO *BmpOut,*BmpIn;
        LPVOID OutBuffer;
        DWORD OutFormatSize,OutBufferSize;
        BmpIn = BmpOutInfo;
        //====================
        CapVar1.hic = ICOpen(CapVar1.fccType,CapVar1.fccHandler,ICMODE_DECOMPRESS);
        OutFormatSize = ICDecompressGetFormatSize(CapVar1.hic,BmpIn);

        BmpOut = new BITMAPINFO[sizeof(OutFormatSize)];
        ZeroMemory(BmpOut,OutFormatSize);

       ICDecompressGetFormat(CapVar1.hic, &BmpIn->bmiHeader , &BmpOut->bmiHeader);





        OutBufferSize = BmpOut->bmiHeader.biSizeImage;

        OutBuffer = new LPVOID[sizeof(OutBufferSize)];

        ICDecompressBegin(CapVar1.hic,BmpIn, BmpOut);






        DWORD result;


        if(VideoData.bKeyFrame!=0)
        {
                result = ICDecompress(CapVar1.hic,0,&BmpIn->bmiHeader,&VideoData.Buf,&BmpOut->bmiHeader,OutBuffer);
        }
        else
        {
                result = ICDecompress(CapVar1.hic,ICDECOMPRESS_NOTKEYFRAME,&BmpIn->bmiHeader,&VideoData.Buf,&BmpOut->bmiHeader,OutBuffer);
        }
        if (result==ICERR_OK)
        {
                SetDIBitsToDevice(Image1->Canvas->Handle,0,0,Image1->Width,Image1->Height,0,0,0,BmpOut->bmiHeader.biHeight ,OutBuffer,BmpOut,DIB_RGB_COLORS);
        }

        if(CapVar1.hic > 0)
        {
                ICDecompressEnd(CapVar1.hic);

                ICCompressorFree(&CapVar1);
                ICClose(CapVar1.hic);
        }

        delete (BmpOut);
        delete (OutBuffer);
}
//---------------------------------------------------------------------------






